"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: RegressionTests }"

TestCase subclass:#ElectronGraphicDeviceTest
	instanceVariableNames:'display'
	classVariableNames:''
	poolDictionaries:''
	category:'tests-Regression-Graphics-Basic'
!

!ElectronGraphicDeviceTest class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    class:
        <a short class summary here, describing what instances represent>

    responsibilities:    
        <describing what my main role is>

    collaborators:    
        <describing with whom and how I talk to>

    API:
        <public api and main messages>
        
    example:
        <a one-line examples on how to use - can also be in a separate example method>

    implementation:
        <implementation points>

    [author:]
        exept MBP

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!ElectronGraphicDeviceTest methodsFor:'tests'!

setUp
    display := ElectronWorkstation newFor:'localhost:8588'.
!

tearDown
    display notNil ifTrue:[
        display close
    ].

!

test_01_ConnectDisconnect
    self assert:(display notNil).
    self assert:(display isOpen).
    display close.
    self assert:(display isOpen not).

    "
     self new test_01_ConnectDisconnect
    "
!

test_02_Properties
    self assert:(display visualType notNil).
    display visualType == #TrueColor ifTrue:[
        self assert:(display hasColors).
        self assert:(display hasGreyscales).
    ].

    self assert:(display depth notNil).
    self assert:(display shiftRed notNil).
    self assert:(display shiftGreen notNil).
    self assert:(display shiftBlue notNil).

    self assert:(display blackpixel == 0).
    self assert:(display whitepixel == 16rFFFFFF).

    "
     self new test_02_Properties
    "
!

test_03_WindowCreation
    |v|

    v := TopView onDevice:display.
    
    "
     self new test_03_WindowCreation
    "
!

test_04_WindowCreateAndMap
    |v|

    v := TopView onDevice:display.
    v realize.
    v destroy.

    "
     self new test_04_WindowCreateAndMap
    "
! !

!ElectronGraphicDeviceTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

